
import curses

class BaseBar(object):
    def __init__(self, main, top, left, width):
        # Reference to the main window
        self.main = main

        # Bar position
        self.top   = top
        self.left  = left
        self.width = width

        # Initialise bar
        self.bar = curses.newwin(1, width, top, left)
        self.color_pair = curses.color_pair(0)
        self._prefix = ''

    def prefix(self, value=''):
        if not value:
            return self._prefix
        self._prefix = value
        self.display(self._msg)

    def display(self, msg):
        self._msg = msg
        if self.prefix:
            msg = self.prefix() + ' ' + msg
        # Curses will raise a 'curses.error' when the last possible character is
        # written. This exception should therefore always be catched. The raised
        # exception truncates the message to the width of the bar.
        try:
            self.bar.addstr(0, 0, msg.ljust(self.width), self.color_pair)
        except curses.error:
            pass
        self.refresh()

    def refresh(self):
        self.bar.refresh()

